package isplay

import (
	"sync"
)

/*
	Потокобезопасный признак проигрывания звука
*/

// IsPlay -- потокобезопасный признак проигрывания звука
type IsPlay struct {
	val   bool
	block sync.RWMutex
}

// NewIsPlay -- возвращает новый *IsPlay
func NewIsPlay() *IsPlay {
	return &IsPlay{}
}

// Get -- возвращает хранимое состояние
func (sf *IsPlay) Get() bool {
	sf.block.RLock()
	defer sf.block.RUnlock()
	return sf.val
}

// Set -- устанавливает хранимое состояние
func (sf *IsPlay) Set() {
	sf.block.Lock()
	defer sf.block.Unlock()
	sf.val = true
}

// Reset -- сбрасывает хранимое состояние
func (sf *IsPlay) Reset() {
	sf.block.Lock()
	defer sf.block.Unlock()
	sf.val = false
}
